//
//****************************************
//**  Copyright  (C)  W.ch  1999-2011   **
//**  Web:  http://www.winchiphead.com  **
//****************************************
//**  DLL for HID interface chip CH9326  **
//**  C, VC6.0                          **
//****************************************
//
// HIDӦòӿڿ  V1.1
// Ͼߺ޹˾  : zyw@wch.cn 2014.08
// HIDDLL  V1.1 
// 
// 
//

#ifndef		_CH9326_DLL_H
#define		_CH9326_DLL_H

#ifdef __cplusplus
extern "C" {
#endif

/*	BAUD rate setting	*/
#define B300		0x01
#define B600		0x02
#define B1200		0x03
#define B2400		0x04
#define B4800		0x05
#define B9600		0x06
#define B14400      0x07
#define B19200		0x08
#define B28800      0x09
#define B38400		0x0A
#define B57600		0x0B
#define B76800      0x0C
#define B115200 	0x0D

/* Parity define	*/
#define P_ODD		0x01        //У
#define P_EVEN		0x02		//żУ
#define P_SPC		0x03		//հλ
#define P_NONE		0x04		//У

/*	Data bits define		*/
#define BIT_5		0x01			
#define BIT_6		0x02
#define BIT_7		0x03
#define BIT_8		0x04

/* Stop bits define	*/
#define STOP_1		0x01			
#define STOP_2		0x02

//ʼDLL⡣
BOOL        WINAPI CH9326DllInt();

//CH9326GetHidGuidȡHIDGUID÷οCH9326DBG
//ȼHidD_GetHidGuid,οMSDN
void        WINAPI CH9326GetHidGuid (void *   HidGuid);

// 豸VID/PID豸
// CH9326OpenDeviceɹ豸ʧܷINVALID_HANDLE_VALUE
HANDLE		WINAPI	CH9326OpenDevice(	unsigned short USB_VID,		        //豸VID
				        unsigned short USB_PID 								//豸PID
				        ); 
				        
// 豸豸
// CH9326OpenDeviceɹ豸ʧܷINVALID_HANDLE_VALUE
HANDLE	WINAPI	CH9326OpenDevicePath(PCHAR DevicePath       //豸
                        );

BOOL	WINAPI	CH9326GetDevicePath(ULONG DevIndex,         //豸ţʾϵͳеڼHID豸
                                    PCHAR DevicePath,       //豸
                                    ULONG DevicePathLen     //DevicePathĻ
                                    );				
//ȼHidD_GetAttributesȡVID,PID汾,οMSDNɹTRUE,ʧܷFALSE
unsigned long	WINAPI CH9326GetAttributes (HANDLE hDeviceHandle,           //豸
                        unsigned short * pVID,                              //豸VID
                        unsigned short * pPID,                              //豸PID
                        unsigned short * pVer                               //豸İ汾
                        );
                
//ȡCH9326ReadDataCH9326WriteDataһζдݳ
//ɹTRUEʧܷFALSE
unsigned long	WINAPI	CH9326GetBufferLen(HANDLE hDeviceHandle,	        //豸
				        unsigned short * InputReportLen,					//ؽݳ
				        unsigned short * OutputReportLen					//طݳ
				        );
				
//CH9326ReadDataCH9326WriteDataдʱλ
void		WINAPI	CH9326SetTimeOut(	HANDLE hDeviceHandle,		        //豸
				        unsigned long ReadTimeOut,							//öݳʱ
				        unsigned long SendTimeOut							//дݳʱ
				        );
				
//һݣ󳤶ΪCH9326GetBufferLenصInputReportLen-2оƬ̼.
//CH9326һ󳤶Ϊ31.ɹTRUEʧܷFALSE
unsigned long	WINAPI	CH9326ReadData(	HANDLE hDeviceHandle,		        //豸
				        void * 			ReadBuffer ,						//ָݻ
				        unsigned long * pReadLen,							//ʵʶݳ
				        HANDLE 			hEventObject						//ȴ¼
				        );
				
//дһݣ󳤶ΪCH9326GetBufferLenصOutputReportLen-2оƬ̼.
//CH9326дһ󳤶Ϊ31.ɹTRUEʧܷFALSE				
unsigned long	WINAPI	CH9326WriteData(	HANDLE hDeviceHandle,           //豸
				        void * 			SendBuffer,							//ָݻ
				        unsigned long	SentLen,							//Ҫݵĳ
				        HANDLE 			hEventObject						//ȴ¼
				        );
/*
ucRate	: 1=300(ucRateΪ1ʱӦ300),2=600,3=1200,4=2400,5=4800,6=9600(Ĭֵ),7=14400,8=19200,9=28800,10=38400,11=57600,12=76800,13=115200
ucCheck	: 1=У,2=żУ,3=հλ,4=У(Ĭֵ)
ucStop	: 1=1λ(Ĭֵ)2=2λ
ucData	1=5λ2=6λ3=7λ4=8λ(Ĭֵ)
*/
//òʣucIntervalΪݵĳʱܵ31
//ҳucIntervalʱûܵݣCH9326ϴPC
//ɹTRUEʧܷFALSE
unsigned long	WINAPI	CH9326SetRate(	HANDLE	hDeviceHandle,	            //豸
					    unsigned char	ucRate,	                            //
					    unsigned char	ucCheck,	                        //Уģʽ
					    unsigned char	ucStop,	                            //ֹͣλ
					    unsigned char	ucData,                             //λ
					    unsigned char	ucInterval                          //HIDʱʱ0x10=3MS((Ĭֵ)),0x20Լ6MS,0x30Լ9MS
					    );	
					
/*
CH9326InitThreadData,CH9326GetThreadDataLen,CH9326ClearThreadData,
CH9326ReadThreadData,CH9326StopThread
麯ҪΪ˷ݲͻʹַʽݡ
CH9326InitThreadData:һ̺߳˽жѣ߳ڲĵCH9326ReadDataݣݻڲ˽жС
CH9326GetThreadDataLen:ȡڲݵĳȡ
CH9326ReadThreadData:ڲݡ
CH9326ClearThreadData:ջݡ
CH9326StopThread:ֹͣڲ̶߳ȡڲ
*/

//ʼ̺߳˽жѣɹTRUEʧܷFALSE
unsigned long 	WINAPI	CH9326InitThreadData(HANDLE hDeviceHandle   //豸
                        );
                        
//ѯݣ̻߳ж
unsigned long 	WINAPI	CH9326GetThreadDataLen(HANDLE hDeviceHandle  //豸
                        );
//߳ݣɹTRUEʧܷFALSE
//ע⣺ReadLenڵ֮ǰΪҪȡݳȣȲܳReadBufferĴСᷢڴ
unsigned long 	WINAPI	CH9326ReadThreadData(HANDLE hDeviceHandle,  //HID豸
                        void * ReadBuffer,                          //׵ַ
                        unsigned long *ReadLen                      //֮ǰΪҪȡݳȣʵʶݳ
                        );
//ջ
void 	        WINAPI	CH9326ClearThreadData(HANDLE hDeviceHandle  //豸
                        );
                        
//ֹͣڲ̶߳ȡڲ
void 	        WINAPI	CH9326StopThread(HANDLE hDeviceHandle       //豸
                        );

//òƷϢʹãرҪעVID/PIDʱ
//豸ʱCH9326OpenDeviceӦVID/PIDҪӦ޸ģʧܡ
//ɹTRUEʧܷFALSE
unsigned long 	WINAPI	CH9326SetDeviceCfg(HANDLE hDeviceHandle,    //豸
                        unsigned short wVID,                        //µVID
                        unsigned short wPID,                        //µPID
                        unsigned short wPower,                      //µ豸,50~150 
                        char* strManufacturer,                      //µĳ
                        unsigned long  uMSlen,                      //µĳȣ29
                        char* strProduct,                           //µĲƷ
                        unsigned long  uPSlen,                      //µĲƷȣ29
                        char* strSerialNo,                          //µĲƷк
                        unsigned long  uSSlen                       //µĲƷкųȣ29
                        );

//ĬϲʣϵĬϲʣʱCH9326Ĭϲ9600οCH9326SetRate
//ɹTRUEʧܷFALSE
unsigned long	WINAPI	CH9326SetDefaultRate(	HANDLE	hDeviceHandle,	    //豸
					    unsigned char	ucRate,	                            //
					    unsigned char	ucCheck,	                        //Уģʽ
					    unsigned char	ucStop,	                            //ֹͣλ
					    unsigned char	ucData,                             //λ
					    unsigned char	ucInterval                          //HIDʱʱ0x10=3MS((Ĭֵ)),0x20Լ6MS,0x30Լ9MS
					    );	

//ָĬãʹCH9326SetDeviceCfgCH9326SetDefaultRateЧ
//ɹTRUEʧܷFALSE
unsigned long	WINAPI	CH9326ResetToDefault(	HANDLE hDeviceHandle 	        //豸
                        );
					
//16λIOڷ򣬳ɹTRUEʧܷFALSE
unsigned long 	WINAPI	CH9326SetIODir(HANDLE hDeviceHandle,                //豸
                        unsigned short usDir                                //16λIOڵãӦλ10                           
                        );
                        
//16λIOڵĵƽɹTRUEʧܷFALSE
unsigned long 	WINAPI	CH9326WriteIOData(HANDLE hDeviceHandle,             //豸
                        unsigned short usData                               //16λIOĸߵ͵ƽãӦλ1ߵƽ0صƽ
                        );

//ȡ16λIOڵŵƽɹTRUEʧܷFALSE                        
unsigned long 	WINAPI	CH9326ReadIOData(HANDLE hDeviceHandle,              //豸
                        unsigned short* pData                               //ȡ16λIOڵŵƽ
                        );   

//ȡַɹTRUEʧܷFALSE 
//ȼHidD_GetManufacturerStringοMSDN 
unsigned long 	WINAPI  CH9326GetManufacturerString (HANDLE hDeviceHandle,  //豸
                        void * Buffer,                                      //׵ַ
                        unsigned long BufferLength                          //С
                        );

//ȡƷַɹTRUEʧܷFALSE 
//ȼHidD_GetProductStringοMSDN 
unsigned long 	WINAPI  CH9326GetProductString(HANDLE hDeviceHandle,        //豸
                        void * Buffer,                                      //׵ַ
                        unsigned long BufferLength                          //С
                        );

//ȡкַɹTRUEʧܷFALSE
//ȼHidD_GetSerialNumberStringοMSDN
unsigned long 	WINAPI  CH9326GetSerialNumberString(HANDLE hDeviceHandle,   //豸
                        void * Buffer,                                      //׵ַ
                        unsigned long BufferLength                          //С
                        );                                                 


//ر豸
void 		    WINAPI	CH9326CloseDevice(HANDLE hDeviceHandle              //豸
                        );

#ifdef __cplusplus
}
#endif

#endif		// _CH9326_DLL_H
